
// Basic class for handling transitions and state for views
var ViewController = function() {
  var me = this;
  me.views = ["ftue", "home", "primer", "battle", "result", "map", "detail"];
  me.active = "ftue";
  
  me.shift = function(to) {
    FX.click();
    if(me.active) $('#'+me.active).hide();
    $('#'+to).show();
    me.active = to;
  };
  
}; var view = new ViewController();

var AppController = function() {
  var me = this;
  me.player = null;
  
  me.init = function() {
    
    // Check the the existance of the player in LocalStorage
    var saved_player = db.get('player');
    
    if (saved_player && saved_player.version !== APP_VERSION) { 
      me.reset();
      saved_player = null;
    }
    
    if (saved_player) {
      me.player = new Player(saved_player);
      mpmetrics.identify(me.player.uid);
    } else {
      // Player doesn't exist.  Initialize
      me.player = new Player();
      me.player.save();
      mpmetrics.identify(me.player.uid);
      mpmetrics.track('create_player');
      me.player.track_ftue_step("create_player");
    }
    
    mpmetrics.track('app_init');
    
    if (!me.player.ftue["selected_mino"]) {
      // Player hasn't been through the ftue.  Start it.
      me.ftue();
    } else {
      me.home();
    }
    
  }
  
  me.ftue = function() {
    $('#mino_choices li').each(function(i) {
      var monster = Starter[i];
      $(this).append( monster_img_tag(monster) );
      $(this).attr('title', monster.name() );
      $(this).bind(DEFAULT_HANDLER, me.select_mino );
    });
    view.shift("ftue");
  }

	me.map = function(level_num) {
	  home.stop_animations();
    view.shift("map_v2");
    mapController.show(level_num);
  }


  me.select_mino = function(event) {
    me.player.track_ftue_step("selected_mino");
    mpmetrics.track('select_mino', {'value':event.currentTarget.title});
    me.player.adopt(event.currentTarget.title);
    me.player.monsters[0].set_to_level(3)
    me.player.progress = 1;
    me.player.save();
    me.primer(0);
  }
  
  me.home = function() {
    view.shift("home");
    home.init();
		me.player.update_energy();
		var player_mino = me.player.active_monster();
		
		$('.feedback').bind(DEFAULT_HANDLER, function() {
		  $('#feedback_box').fadeIn('slow');
		});
		
		$("#home").bind(DEFAULT_HANDLER, function(e) {
      if($(e.target).is($("#feedback_box"))) return;
      if($(e.target).is($(".feedback"))) return;
    $('#feedback_box').fadeOut('slow');
    });


  }
  
  me.primer = function(location_id) {
    set_back_button(null);
    var location = World[location_id];
    var player_mino = me.player.active_monster();
    
    if (player_mino.dead()) {
      var any_living = false;
      $.each(me.player.monsters, function (i,monster) {
        if (!monster.dead()) {
          me.player.active = i;
          any_living = true;
        }
      });
      if (!any_living) {
        // we need to break out here
        alert('Your whole party is dead!');
        return;
      }
      player_mino = me.player.active_monster();
    }
    var background = 'url(i/field-' + location.area + '.png)';
    $('#primer').css('background-image',background);
    $('#primer').unbind().bind(DEFAULT_HANDLER, function () {
      _app.battle();
    });
    view.shift("primer");
    me.player.current_location = location_id;
    
    $('#battle-field').removeClass().addClass(location.area);

    // Get a monster to fight
    if (me.player.enemies_defeated_at(location_id) < location.monsters.length) {
      var next_enemy_index = me.player.enemies_defeated_at(location_id);
    } else {
      var next_enemy_index = rand(0, location.monsters.length - 1);
    }
    
    me.player.current_enemy = next_enemy_index;
    var next_enemy = npc_monster( location.monsters[next_enemy_index] );
    battle.queue(next_enemy, location_id);
    
    me.player.save();
    
    $('#primermonster-right').attr("src", next_enemy.img());
    $('#primermonster-left').attr("src", player_mino.img());
    
    $('#level_information').html('Level ' + (location_id + 1));
  }
  
  me.battle = function() {
    view.shift("battle");
    
    if (!me.player.ftue["attacked_once"]) {
      $('#ftue_first_battle').show();
      $('#monster-enemy').css('z-index', '1001');
    } else {
      $('#monster-enemy').attr('style', '');
    }
    
    battle.start();
    me.next_monster = null;
  }

  me.battle_win = function(){
    view.shift("battle-win");
  }
  
  me.reset = function() {
    db.set('player', null);
  }
  
  me.save = function() {
    me.player.save();
  }
  
}; var _app = new AppController();


var DatabaseConnection = function() {
  var me = this;
  me.set = function(var_name, value){
      localStorage.setItem(var_name, JSON.stringify(value));
      return me;
  }
  me.get = function(var_name) {
      return (localStorage.getItem(var_name) ? JSON.parse(localStorage.getItem(var_name)) : false);
  }
}; var db = new DatabaseConnection();


// This sets the framerate that JQuery runs it's animations
// || Interval || Framerate
// ||----------||-----------
// || 100ms    || 10fps
// ||  50ms    || 20fps
// ||  33ms    || 30fps
// ||  16ms    || 60fps

jQuery.extend( jQuery.fx, { interval: 16 } );


//
// Playing music and sound effects
//

var muted = false;
var MusicCache = {};

function play_music(fname, repeat, filetype) {
  return;
  if (phonegap && !muted) {
    if(!MusicCache[fname]) {
      var ft = (filetype) ? filetype : '.mp3'
      MusicCache[fname] = new Media('/android_asset/m/'+fname+ft);
    }
    // var opt = (repeat) ? {numberOfLoops:99} : {}  // Turns out this doesnt do anything.
    MusicCache[fname].play();
  }
}

var FX = {
  punch: function()  { return; play_music("punch_1", false, ".wav"); },
  click: function()  { return; play_music("click"); },
  doober: function() { return; play_music("doober_"+rand(1,3)); }
}

function mute() {
  muted = true;
  $("#mute_icon").hide();
  $('#unmute_icon').show();
  if (phonegap) {
    $.each(MusicCache, function(k, v) {
      v.stop();
    });
  }
};

function unmute() {
  muted = false;
  $("#mute_icon").show();
  $('#unmute_icon').hide();
  // play_music('battle_2_loop', true);
}


//
// Pay Us Monies
//
function pay(message){
  var result = confirm(message);
  
  if(result) {
    mpmetrics.track_funnel('pay_revive',2,'confirm');
    if(!_app.player.free_refill) {
      mpmetrics.track_funnel('pay_revive',3,'free_revive');
      //heal all monsters.
      $('.deadbox').hide();

      $.each(_app.player.monsters, function (i,monster) {
        monster.revive();
      });
  
      mpmetrics.track('pay_revive');
      _app.player.free_refill = true;
      _app.player.save();
      home.show();
      alert("We refilled your account for free!");
    } else {
      alert("Sorry, this feature is unavailable");
    }
  }
  return false;
}


document.addEventListener("deviceready", function(){
  phonegap = true;
  document.addEventListener("backbutton", backKeyDown, true);

  // play_music('battle_2_loop', true);
}, true);


$(document).ready(function() {
  
  if(ENV === "production") $('.debug').hide();
  
  // Start Mixpanel Tracking
  try {
    
    if(ENV === "development")
      mpmetrics = new MixpanelLib(DEVELOPMENT_MIXPANEL_TOKEN);
    else  
      mpmetrics = new MixpanelLib(PRODUCTION_MIXPANEL_TOKEN);
  } catch(err) {
      var null_fn = function () {};
      mpmetrics = { 
          track: null_fn, 
          track_funnel: null_fn, 
          register: null_fn, 
          register_once: null_fn,
          register_funnel: null_fn,
          identify: null_fn
      };
  }
  
  
  // Start application
  _app.init();
  
});


// Mixpanel debugging code
// var null_fn = function () {};
// mpmetrics = { 
//     track: null_fn, 
//     track_funnel: function() { console.log("OLD: "+JSON.stringify(arguments))}, 
//     track_funnelx: function() { console.log(JSON.stringify(arguments))}, 
//     register: null_fn, 
//     register_once: null_fn,
//     register_funnel: null_fn,
//     identify: null_fn
// };