var DetailController = function (){
  var me = this;
  me.initialized = false;
  
  me.animate = function () {
      if (_app.player.active_monster().dead()) {return;}
      $('#detail-monster').animate({scaleX:1.0},rand(0,3000))
      .animate({bottom: 35},100 + rand(0,100))
      .animate({bottom: 30},100,'linear',function () {
        if (view.active == "detail") {
          me.animate();
        }
      });
  };
  
  me.show = function() {
    var active_monster = _app.player.active_monster();
    
    // display skills
    $('#skills_container').empty();
    
    $.each( active_monster.skills, function(i, v) {
      var skill = $("<img src='i/attacks/"+v.name+".png' />");
      if ( !v.learned )
        skill.addClass("inactive");
      $('#skills_container').append(skill);
    })
    $('#skills_container').unbind().bind(DEFAULT_HANDLER, function() { detail.skills(); });
    
    // Display Monster Icon
    if ($('#detail-monster').attr('src') != active_monster.img()) {
      // we have switched mon, revert the shadow o' death
      Pixastic.revert($('#detail-monster').get(0));
    }
    
    $('#detail-monster').attr('src', active_monster.img());
    if (active_monster.dead()) {
      setTimeout(function () {$('#detail-monster').pixastic("coloradjust", {red:-1.0,green:-1.0,blue:-1.0})},1);
    } else {
      Pixastic.revert($('#detail-monster').get(0));
    }
    me.animate();
    
    // Display Monster Name
    $('#detail-monster-name').html(active_monster.name().toUpperCase());
    
    // Display XP
    style_bar_from_percent( $('#xp_bar'), active_monster.level_complete_percent() );
    $('#xp_level').text(active_monster.level);
    
    // Display HP
    style_bar_from_percent( $('#hp_bar'), active_monster.hp_percent() )
    
  };
  
  me.skills = function() {
    var active_monster = _app.player.active_monster();
    
    mpmetrics.track('skill_tree');
    
    $('#skills_display_close').unbind().bind(DEFAULT_HANDLER, function() { detail.close_skills(); })
    $('#skills_display').show();
    $('#skills_display').unbind().bind(DEFAULT_HANDLER, function() { detail.close_skill_detail(); } );
    
    $('#candy_holder').empty();
    for( var i=0; i<5; i++) {
      if ( i < active_monster.candy ) {
        $('#candy_holder').append('<img src="i/skills-candy-full.png" />');
      } else {
        $('#candy_holder').append('<img src="i/skills-candy-empty.png" />');
      }
    }
    
    var in_progress_marked = false;
    $.each( active_monster.skills, function(i, v) {
      
      var skill_node = $("#skill_node_"+(i+1));
      var skill_branch = $("#skill_branch_"+(i+1));
      skill_node.removeClass("learned in_progress unlearned").show();
      skill_branch.removeClass("learned in_progress unlearned").show();
      
      if (v.learned) {
        skill_node.addClass("learned");
        skill_branch.addClass("learned");
      } else if (!in_progress_marked) {
        in_progress_marked = true;
        skill_node.addClass("in_progress");
        skill_branch.addClass("in_progress");
      } else {
        skill_node.addClass("unlearned");
        skill_branch.addClass("unlearned");
      }
      
      skill_node.unbind().bind(DEFAULT_HANDLER, function(event) {
        detail.slide_skill_tree(220 - $(this).position().left);
        $('#skill_detail_arrow').animate({ ypos: ($(this).position().top - 122), fastAnimate:true  });
        detail.skill_detail(v);
        event.stopPropagation();
      });
      
      $("#skill_node_"+(i+1)+" > img").attr("src", "i/attacks/"+v.name+".png");
    });
    
    for( var i = 4; i > active_monster.skills.length; i-- ) {
      $("#skill_node_"+i).hide();
      $("#skill_branch_"+i).hide();
    }
    
    var num_skills = active_monster.skills_known();
    $('#num_learned .amount').text(num_skills);
    $('#num_learned .label').text((num_skills == 1 ? "SKILL" : "SKILLS")+" KNOWN");
  }
  
  me.skill_detail = function(skill) {
    $('#num_learned').fadeOut();
    // $('#skills_switcher').fadeOut();  // Temp disabled.
    $('#skill_detail_holder').show();
    $('#skill_detail').animate({ xpos: 0, fastAnimate:true  });
    $('#skill_detail_name').text(skill.friendly_name);
    $('#skill_detail_power_data').text(skill.power);
    $('#skill_detail_data').empty();
    if( skill.learned ) {
      $('#skill_detail_data').append("<li class='learned'>Known</li>")
    } else {
      $('#skill_detail_data').append("<li>Learn at level "+skill.level+"</li>")
    }
  }
  
  me.close_skill_detail = function() {
    $('#num_learned').fadeIn();
    // $('#skills_switcher').fadeIn();  // Temp. disabled.
    $('#skill_detail').animate({ xpos: 152, fastAnimate:true  }, function() { $('#skill_detail_holder').hide(); });
    me.slide_skill_tree(0);
  }
  
  me.slide_skill_tree = function(scroll_to) {
    $('#skill_tree').animate({ xpos: scroll_to, fastAnimate:true }, 500);
  }
  
  me.close_skills = function() {
    $('#skills_display').hide();
  }
  
  me.init = function () {
    if (!me.initialized) {
      // back button
      var go_back = function () {
        $('#detail-monster').stop();
        set_back_button(null);
        view.shift('home');
      };
      
      $('#detail-back').bind(DEFAULT_HANDLER, go_back)
      set_back_button(go_back);
      
      $('#detail_release').bind(DEFAULT_HANDLER,function (event) {
        if (_app.player.monsters.length == 1) return;
        if (_app.player.active_monster().dead()) {
          alert("That would just be mean.")
          mpmetrics.track('dead_release');
          return;
        }
        if (confirm("Are you sure you want to release " + _app.player.active_monster().name() + "?")) {
          // release
          _app.player.monsters.splice(_app.player.active,_app.player.active);
          _app.player.active = 0;
          _app.player.save();
          // mpmetrics.track('detail_release', {monster: _app.player.active_monster().name()});
          home.show();
          view.shift('home');
        } 
      })
    }
    me.initialized = true;
  }
}; var detail = new DetailController();
