var HomeController = function() {
  var me = this;
  me.initialized = false;
  me.tick_timer = null;
  me.all_monsters_dead = function () {
    for (var i = 0; i < _app.player.monsters.length; i++) {
      if (!_app.player.monsters[i].dead()) return false;
    }
    return true;
  }
  me.show = function() {
    var active_monster = _app.player.active_monster();
    me.monster_concerns = [[],[],[],[]];
    

    //Ask for $1 if their party is dead. Let's make it rain!!!
    if (me.all_monsters_dead()) {
      // Your whole party is dead bro
      $('.deadbox').fadeIn('slow');
    }
    
    if (_app.player.inventory_food_size() == 0)
      $('#show_food_button').hide();
    else
      $('#show_food_button').show();
    
    $('#show_food_button').unbind().bind(DEFAULT_HANDLER, function() {
      me.open_feeding_drawer();
      return false;
    })
    
    me.build_inventory_display();

    // Display Monster Icon
    for (var i = 0; i < 4; i++) {
      $('#home-monster' + (i+1) ).css('opacity', 0.0);
      $('#concern' + (i+1)).css('opacity', 0.0);
    }
    
    $('.monsterinfo_container').empty();
    $('.monster_likes_food').remove();
    $('.feed_button').remove();

    $.each(_app.player.monsters, function (monster_index, monster) {
      

      // MVC bah
      monster.avatar_id = '#home-monster' + (monster_index+1);
      var monster_node = $(monster.avatar_id);
      var monster_img_node = $(monster.avatar_id + " img");
      
      
      //Display monster info
      $('#monsterinfo' + (monster_index+1)).html('<div class="monsterinfo">' + monster.name().toUpperCase() + ' <span id="lvl">Lvl ' + monster.level + '</span></div>');
      
      
      if (!monster.dead()) {
        var feed_button = $('<img class="feed_button" src="i/home-feed-button.png" id="feed_button' + (monster_index+1) + '" />');
        feed_button.bind(DEFAULT_HANDLER, function() {
          home.deliver_food(monster);
        });
        $('#home').append(feed_button);
        $('#home').append("<div class='monster_likes_food' id='food_pref"+(monster_index+1)+"'>Loves <img src='i/doobers/"+monster.food_preference+"-1.png' /></div>");
      }

      
      var y = monster_index;
    
      // Calculate and display concerns
      $.each( Concerns, function(i, v) {
        if( v.test( monster ) ) {
          me.monster_concerns[monster_index].push(v);
        };
      });
      
      // Sort concerns from highest to lowest
      me.monster_concerns[monster_index].sort( function(a, b) {
        return b.priority - a.priority;
      });
      
      monster_node.css('opacity', 1.0);
      
      monster_img_node.bind("load", function(){
        var scroll_to_pos = 150 - monster_img_node.height();
        monster_img_node.stop(true).css('top', 0).animate({ypos:scroll_to_pos, fastAnimate:true});
        me.deadify(monster);
      });
      monster_img_node.attr('src', monster.img());
      
      
      
      $('#home-monster' + (monster_index+1)).unbind().bind(DEFAULT_HANDLER, function (event) {
        home.care( y );
      });
      
      
      $('#concern' + (monster_index+1)).css('opacity', monster.dead() ? 0.0 : 1.0); // no concerns shown if dead
      if (me.monster_concerns[monster_index].length > 0) {
        $('#concern' + (monster_index+1)).css('background-image', "url("+me.monster_concerns[monster_index][0].icon+")");
      } else {
        $('#concern' + (monster_index+1)).css('background-image', '');
      }
    });
    
    if (me.tick_timer === null)
      me.tick_timer = setInterval(home.tick,1500);
    
    // me.start_animations();
  };
  
  me.care = function( monster_index ) {
    var selected_monster = _app.player.monsters[ monster_index ];
    
    if (me.feeding_drawer_open) return;
    
    if (me.feeding_mode_active) {
      if (!selected_monster.dead()) me.deliver_food(selected_monster);
      return;
    }
    
    if (me.monster_concerns[ monster_index ].length > 0 && !selected_monster.dead()) {
      var concern = me.monster_concerns[ monster_index ].shift();
      concern.respond( selected_monster );
      
      // mpmetrics.track('care', {name: concern.name});
      
      _app.player.save();
      if (me.monster_concerns[ monster_index ].length > 0) {
        $('#concern' + (monster_index+1)).css('background-image', "url("+me.monster_concerns[ monster_index ][0].icon+")");
      } else {
        $('#concern' + (monster_index+1)).css('background-image', '');
      }
    } else {
      _app.player.active = monster_index;
      detail.init();
      detail.show();
      mpmetrics.track('detail', { monster: selected_monster.name(), dead: selected_monster.dead()} );
      me.stop_animations();
      view.shift('detail');
    }
    
    
    if (me.monster_concerns.length > 0) {
      $('#concern').css('background-image', "url("+me.monster_concerns[_app.player.active].icon+")");
    } else {
      $('#concern').css('background-image', '');
    }
    
    
  }
  me.tick  = function() {
    if (view.active == "home") {
      // determine if mino is still dead or not
      var pending_level_ups = 0;
      $.each(_app.player.monsters, function (i,monster) {
        pending_level_ups += monster.dead() ? 0 : monster.pending_level_ups.length;
        monster.tick();
        me.deadify(monster);
        $(monster.avatar_id + ' .death_timer').css('opacity',monster.dead() ? 1.0 : 0.0);
        var time_til_revive = monster.dead_until - current_timestamp();
        var s;
        
        if (time_til_revive < 60 && time_til_revive > 10) {
          s = 'Revives in ' + time_til_revive + 's';
        } else if (time_til_revive < 10) {
          s = monster.name() + ' is reviving!!';
        } else {
          s = 'Revives in ' + time_string_for_timestamp(time_til_revive);
        }
        
        if (time_til_revive == 3) {
          $(monster.avatar_id).stop(true).animate({'opacity': 1.0}, 500)
          .animate({'opacity': 1.0}, 500)
          .animate({'opacity': 0.0}, 500)
          .animate({'opacity': 1.0}, 500)
          .animate({'opacity': 0.0}, 500)
          .animate({'opacity': 1.0}, 500)
        }
        
        $(monster.avatar_id + ' .death_timer').html(s);
      });
    if (pending_level_ups == 0) $("#map_back_button").attr('src','i/arrow_back.png');
      
      _app.player.save();
      
      // trigger a show to rerender the game state
      // me.show();
      
    }
      
      
  }
  
  me.animating = false;
  me.animate = function () {
    if (!me.animating) return;
    $.each(_app.player.monsters, function (i,monster) {
      var monster_img = $(monster.avatar_id + ' img');
      
      
      monster_img.stop();
      if (monster.dead()) { return;}
      var from_top = 150 - monster_img.height();
      monster_img.delay(rand(0, 3000))
        .animate({ypos: from_top - 5, fastAnimate:true},100 + rand(0,100))
        .animate({ypos: from_top, fastAnimate:true},100); 
    });
    setTimeout(me.animate, 3400);
  }
  
  me.start_animations = function () {
    if (!me.animating) {
      me.animating = true;
      me.animate();
    }
  }
  
  me.stop_animations = function () {
    if (me.animating) {
      me.animating = false;
    }
  }
  
  me.init = function() {
    if (!me.initialized) {
      me.initialized = true;
      
      $('.start_battle').bind(DEFAULT_HANDLER, function(){
        if (!me.feeding_mode_active && !me.feeding_drawer_open) {
          _app.map();
        }
      });
      
      // calculate how much poo to generate
      $.each(_app.player.monsters, function (i,monster) {
        if (monster.dead()) {
          return;
        }
        var time_since_last_seen = current_timestamp() - monster.last_tick_time;
        var times_pooped = Math.floor(Math.round(time_since_last_seen / (60*60))*Math.random());
        times_pooped  = times_pooped > 25 ? 25 : times_pooped; // clamp the poo
        for (var x = 0; x < times_pooped; x++) {
          // generate a poop spot
          var monster_obj = $(monster.avatar_id + " > img");

          var poopx = monster_obj.offset().left + (monster_obj.width()  - 37.0) / 2.0 + Math.floor(Math.random()*monster_obj.width()) - monster_obj.width()/2;
          var poopy = 270 - Math.floor(Math.random()*50);
          // Generate a poop doober
          new Doober( {
              "context"         : "poop",
              "type"            : "poop",
              "startx"          : poopx, 
              "starty"          : poopy, 
              "endx"            : poopx, 
              "endy"            : poopy, 
              "destx"           : -100, 
              "desty"           : 100, 
              "parent_node"     : '#home', 
              "auto_kill"       : false, 
              "pickup_duration" : 1, 
              "owner"           : monster
              } );
        }
      });
    }
    
    me.show();

  }
  
  me.toggle_ui_display = function(bit) {
    if (bit) {
      
      if (_app.player.inventory_size() == 0)
        $('#show_food_button').hide();
      
      $('.monsterinfo_container').animate( {opacity:1.0});
      $('.start_battle').animate( {opacity:1.0});
      $('#show_food_button').animate( {opacity:1.0});
      $('.concern').animate( {opacity:1.0});
      $('.doober').animate( {opacity:1.0});
    } else {
      $('.monsterinfo_container').animate( {opacity:0.0});
      $('.start_battle').animate( {opacity:0.0});
      $('#show_food_button').animate( {opacity:0.0});
      $('.concern').animate( {opacity:0.0});
      $('.doober').animate( {opacity:0.0});
    }
  }
  
  me.close_feeding_drawer = function(canceled_feeding) {
    me.feeding_drawer_open = false;
    $('#home').unbind(DEFAULT_HANDLER);
    $('#food_container').animate( {ypos: 300, fastAnimate:true},  500);
    if(canceled_feeding) {
      me.toggle_ui_display(true);
    }
  }
  
  me.feeding_drawer_open = false;
  me.open_feeding_drawer = function() {
    mpmetrics.track('feeding_drawer');
    me.feeding_drawer_open = true;
    $('#home').bind(DEFAULT_HANDLER, function() {home.close_feeding_drawer(true);});
    $('#food_container').animate( {ypos: 204, fastAnimate:true},  500);
    me.toggle_ui_display(false);
  }
  
  me.feeding_mode_active = false;
  me.deliver_food = function(monster) {
    if (_app.player.consume_item(me.selected_food)) {
      _app.player.save();
      mpmetrics.track('deliver_food', {matched_preference: (me.selected_food == monster.food_preference)})
      me.build_inventory_display();
      var img = $("<img src='i/doobers/"+me.selected_food+"-1.png' class='food_drop' />");
      var xdest = $(monster.avatar_id).offset().left + ($(monster.avatar_id).width()  - 37.0) / 2.0;
      var ydest = $(monster.avatar_id).offset().top  + ($(monster.avatar_id).height()) / 2.0;
      var foodstuff = me.selected_food;
      $('#home').append(img);
      img.animate({ypos:[ydest, 'easeOutBounce'], xpos: xdest, fastAnimate:true}, 800, function(){
        if (foodstuff == monster.food_preference) {
          generate_homescreen_doobers(4, monster);
          me.animate_happy_jump(monster);
        } else if (include(['cake', 'pie', 'meat'], foodstuff)) {
          generate_homescreen_doobers(1, monster);
          me.animate_happy_jump(monster);
        } else {
          me.animate_sad_face(monster); 
        }
      }).animate( { scale: 2.0, opacity: 0.0, fastAnimate:true }, 200)
      
      me.selected_food = null;
      $('.feed_button').hide();
      $('.monster_likes_food').hide();
      me.feeding_mode_active = false;
      setTimeout(function() {
        $('.food_drop').remove();
        home.toggle_ui_display(true);
      }, 1500);
    }
  }
  
  me.activate_feeding_buttons = function() {
    me.feeding_mode_active = true;
    $('.feed_button').show();
    $('.monster_likes_food').show();
  }
  
  me.animate_happy_jump = function(monster) {
    var thought_bubble = $("<img src='i/home-thought-happy.png' class='thought_bubble' />");
    thought_bubble.css('left', $(monster.avatar_id).offset().left + 30);
    $('#home').append(thought_bubble);
    thought_bubble.delay(1000).animate({opacity:0}, 300, function() { thought_bubble.remove(); });
    
    var monster_img_node = $(monster.avatar_id + ' img');
    var from_top = 150 - monster_img_node.height();
    
    monster_img_node.stop(true)
      .animate({ ypos: from_top - 35, fastAnimate:true},200)
      .animate({ ypos: from_top,      fastAnimate:true},300, 'easeInQuad')
      .animate({ ypos: from_top - 25, fastAnimate:true},150)
      .animate({ ypos: from_top,      fastAnimate:true},250, 'easeInQuad')
      .animate({ ypos: from_top - 15, fastAnimate:true},100)
      .animate({ ypos: from_top,      fastAnimate:true},200, 'easeInQuad');
  }
  
  me.animate_sad_face = function(monster) {
    var thought_bubble = $("<img src='i/home-thought-sad.png' class='thought_bubble' />");
    thought_bubble.css('left', $(monster.avatar_id).offset().left + 30);
    $('#home').append(thought_bubble);
    thought_bubble.delay(1000).animate({opacity:0}, 300, function() { thought_bubble.remove(); });
    
    $(monster.avatar_id).stop(true).jrumble({ duration: 500, rangeRot:0 });
  }
  
  me.build_inventory_display = function() {
    // Add food inventory to feeding box
    $('#food_container').empty();
    $.each(_app.player.inventory, function(v, count){
      if (count > 0 && v !== 'candy') {
        var img = $("<div><img src='i/doobers/"+v+"-1.png' /><div class='count'>"+count+"</div></div>");
        var foodstuff = v;
        img.bind(DEFAULT_HANDLER, function(event) {
          event.preventDefault();
          home.close_feeding_drawer();
          home.activate_feeding_buttons();
          home.selected_food = foodstuff;
        });
        $('#food_container').append(img);
      }
    });
  }
  
  me.deadify = function(monster) {
    var img_node = $(monster.avatar_id + " img");
      var isCanvas = $(monster.avatar_id + ' .home-monster-image').get(0).tagName.toUpperCase() == 'CANVAS';
      if (monster.dead() && !isCanvas) {
        setTimeout(function() {img_node.pixastic("coloradjust", {red:-1.0,green:-1.0,blue:-1.0});}, 500);
      } else if (!monster.dead() && isCanvas) {
        Pixastic.revert($(monster.avatar_id + ' .home-monster-image').get(0));
      }
    
  }
  
}; var home = new HomeController();
