var MapController = function() {
  var me = this;
  me.player = null;
  
  this.mapX = 1447;
  this.mapY = 2166;
  
  me.show = function (level) {
    var player_progress = _app.player.progress;
    if (level === undefined) level = player_progress - 1;
    var buttons = '';
    for (var i = 0; (i < World.length) && (i <= player_progress + 1); i++) {
      buttons += me.map_node_div(i);
    }
    
    $('#map_fullsize').html(buttons);
    for (var i = 0; i < World.length; i++)  {
      var func = function() {
        var x = i;
        $('#map_node' + i).bind(DEFAULT_HANDLER, function (e) {
          _app.primer(x);
        });
      }
      func();
    }
    
    scroller = new iScroll('map_viewport');
    
    
    var map = $('#map_viewport');
    
    var last_level_coords = me.get_node_location($('#map_node'+level), map);
    var next_level_coords = me.get_node_location($('#map_node'+(level+1)), map);
    
    scroller.scrollTo(last_level_coords[0], last_level_coords[1]);
    scroller.scrollTo(next_level_coords[0], next_level_coords[1], 1000);
    
    setTimeout(function() {
      $('.mastery .level_mastery_monster').each(function(i, v) {
        $(v).pixastic("coloradjust", {
            red: 1.0,
            green: -1.0,
            blue: -1.0
          })
        });
      },100);
    }
    
  me.map_node_div = function (i) {
    
    var map_x = World[i].mapX;
    var map_y = World[i].mapY;
    
    
    if ( i == _app.player.progress + 1) {
      return '<div class="loc_node locked" id="map_node'+ i + '" style="top: ' + (map_y - 48/2) + 'px; left: ' + (map_x - 48/2) + 'px;">';
    }
    
    if (_app.player.has_mastered(i)){
      var loc_node_class = "mastered";
    } else {
      var loc_node_class = "unlocked";
    }
    
    var map_button = '<div class="loc_node '+loc_node_class+'" id="map_node'+ i + '" style="top: ' + (map_y - 58/2) + 'px; left: ' + (map_x - 72/2) + 'px;">';
    map_button += '<span class="level_num">'+(i+1)+'</span><div class="mastery">';
    var monster_checks = '<div class="mastery_finished">';
    $.each(World[i].monsters, function(monster_index, monster) {
      var img_class = (_app.player.level_mastery[i][monster_index]) ? '' : 'level_mastery_monster';
      map_button += "<img class='" + img_class + "' src='i/m/" + Monsters[monster.name].img + "' />";
      monster_checks += "<img class='" + img_class + "' src='i/level-mastery-tick.png' />";
    });
    monster_checks += "</div>";
    map_button += '</div>' + monster_checks + '</div>';
    return map_button;
  }
  
  me.get_node_location = function(node, map) {
    if (node.length == 0) return [0,0];
    var left  = -1 * (parseInt(node.css('left')) + node.width()/2  - map.width()/2);
    var top   = -1 * (parseInt(node.css('top'))  + node.height()/2 - map.height()/2);
    if (left > 0) left = 0;
    if (top  > 0) top  = 0;
    return [left, top];
  }
  
  me.init = function() {
    
  }
}; mapController = new MapController();