APP_VERSION = "0.2";

var ENV = (navigator.userAgent.indexOf("Mac OS") >= 0) ? "development" : "production";

var DEFAULT_HANDLER = ENV == "development" ? "click" : "touchstart";
if (navigator.userAgent.indexOf("iPhone") >= 0)  {
  DEFAULT_HANDLER = "touchstart";
  ENV = "production";
}
//
// Mixpanel Configuration
//
var PRODUCTION_MIXPANEL_TOKEN  = "937ea6508c7259815b42ed05a8950aee"
var DEVELOPMENT_MIXPANEL_TOKEN = "3c3869853e6549ab6de5ddd2e7add86c"

var phonegap = false;


// Prevent scrolling
var touchMove = function(event) { event.preventDefault(); }

function rand(min,max) { if(arguments.length===0){min=0;max=2147483647;}; return Math.floor(Math.random()*(max-min+1))+min};

function log(logtext) { document.getElementById("log").innerHTML = logtext; }

function flog(logtext) { log(logtext); setTimeout(clear_log, 1500); }

function clear_log() { log(""); }

function kill_party() { 
  $.each(_app.player.monsters,function (i,monster) {
    monster.take_damage(-1000);
  });
}

function current_timestamp() { return Math.round(+new Date()/1000); }


function calculate_damage(skill, attacker, defender) {
  // Base level of damage based on the skill
  var base_dmg = rand(skill.min_dmg, skill.max_dmg);
  
  // Damage modified by monsters attack power
  var attack_power_mod = attacker.attack_power / 14.0;
  
  var total_attack_damage = base_dmg + attack_power_mod;
  
  var elemental_level_modifier = 0;
  if ( element_strong_against( attacker.element, defender.element ) ) {
    elemental_level_modifier = 3;
  } else if ( element_weak_against( attacker.element, defender.element ) ) {
    elemental_level_modifier = -3;
  }
  
  // Damage reduction from emulated "miss"
  var level_difference = attacker.level - defender.level + elemental_level_modifier;
  if (level_difference > 2 || level_difference < -2) {
    var miss_reduction = 0.02 + (-1 * level_difference) * 0.02;
  } else {  
    var miss_reduction = 0.05 + (-1 * level_difference) * 0.005;
  }
  
  if (miss_reduction < 0) miss_reduction = 0;
  
  // Damage Reduction from defense
  var armor_reduction = defender.defense / ( defender.defense + 40 + 8.5 * (attacker.level + elemental_level_modifier));
  if (armor_reduction < 0) armor_reduction = 0;
  
  var total_damage_reduction = (1.0 - armor_reduction - miss_reduction);
  
  
  
  var total_dmg = Math.round(-1 * total_attack_damage * total_damage_reduction);
  if (total_dmg > -1) total_dmg = -1;
  return total_dmg;
}

function getScaleFromMatrix(matrix) {
  return parseFloat(parseMatrixTransformCSS(matrix)["scale"]);
}

function parseMatrixTransformCSS(matrix) {
  var values = matrix.substring(7,matrix.length -1).split(", ");
  return {scale:values[0], scaleX:values[0], scaleY:values[3], x:values[4], y:values[5]};
}

function style_bar_from_percent(elem, perc_complete) { 
  var bar_placement = (1 - perc_complete) * 100 + "%";
  elem.css('right', bar_placement);
}

//
// Array Helper Functions
//
// pick(): Get a random item from the list
function pick(obj) {
  var obj_type = $.type(obj)
  if ( obj_type === "array") {
    return obj[ rand(0, obj.length - 1) ];
  } else if ( obj_type === "object") {
    return obj[ pick( Object.keys(obj) ) ];
  }
}

// select(): Return items from the list that match the callback
function select(arr, callback) {
  var tmparr = [];
  $.each(arr, function(i,v){
    if( callback.call(null, v) )
      tmparr.push(v);
  });
  return tmparr;
}

function map(arr, callback) {
  var tmparr = [];
  $.each(arr, function(i,v){ tmparr.push(callback.call(null, v)); });
  return tmparr;
}

function num_with_precision( num, precision ) {
	var pow10s = Math.pow( 10, precision );
	return Math.round( pow10s * num ) / pow10s;
};

function average( arr ) {
	var sum = 0;
	$.each( arr, function(i, v){ sum += v; });
	return sum * 1.0 / arr.length;
};

function variance( arr ) {
	var avg = average( arr );
	var sum = 0;
	$.each( arr, function(i, v) { 
	  sum += Math.pow( (v - avg), 2 ); 
	});
	return sum / arr.length;
};

function std_dev( arr ) {
	return Math.sqrt( variance( arr ) );
};

// Not actually the median lol.
// function median( arr ) {
//   return arr[ Math.round( arr.length / 2.0 ) ];
// }

function include( arr, elem ) {
  return arr.indexOf(elem) >= 0;
}

function sum_if( arr, proc ) {
  var sum = 0;
  $.each(arr, function(i,v){ if (proc.call(null, v)) sum += v; });
  return sum;
}

function count_if( arr, proc ) {
  var sum = 0;
  $.each(arr, function(i,v){ if (proc.call(null, v)) sum += 1; });
  return sum;
}


function roll_loot_table(arr) {
  var weights = 0;
  var total = 0;
  $.each(arr, function(i, v) {
    total += v[1];
  });
  var roll = total * Math.random();
  var rolled_index = -1;
  while(roll > 0) {
    rolled_index += 1;
    roll -= arr[rolled_index][1];
  }
  return arr[rolled_index][0];
}


function time_string_for_timestamp(t) {
  var hours = t/3600;
  var mins = Math.floor((hours - Math.floor(hours))*60)
  hours = Math.floor(hours);
  
  var s = '<br/>' + hours + ' hour ';
  if (mins < 10) s += '';
  s += mins + " min";
  return s;
}

var back_button_method = null;
function set_back_button(proc) {
  back_button_method = proc;
}

function backKeyDown() { 
 	if (back_button_method) {
 	  back_button_method.call();
 	  back_button_method = null;
 	}
}

var Battle_Doobers = ['star', 'heart', 'energy'];
var Food_Doobers = ['meat', 'pie', 'cake', 'bug', 'apple', 'banana'];
